# Contributing

Let's create together! We want to make contributing to this project as easy and transparent as possible, whether it's:

- Reporting a bug
- Discussing the current state of the code
- Submitting a fix
- Proposing new features
- Becoming a maintainer

## Pull Request Process

All code changes happen through pull requests.

1. Fork the repo
2. Create your branch from **master** (`git checkout -b feature/spaceship`)
3. Make your changes and test your code
4. Commit your changes (`git commit -am 'Add spaceship feature'`)
5. Push to the branch (`git push origin feature/spaceship`)
6. Create a new Pull Request to the **dev** branch

## After PR

Your PR will be reviewed by us and it must pass various predefined tests, finally, your PR will be merged with our **dev** branch. Once
in a while we merge **dev** and **master** branches and create a new release. We will handle version updating, final CHANGELOG, and similar
procedures.

## Conventions

Keep it consistent!

## Report bugs using Github's issues
We use GitHub issues to track bugs. Report a bug by opening a new issue.

## Request features and improvements
Check out our [Roadmap](https://community.iotaap.io/t/roadmap/77), request features and improvements by [creating a new topic](https://community.iotaap.io/c/iotaap-os/features/15).

## Write bug reports with detail, background, and sample code
Be clear and informative

**Great Bug Reports** tend to have:

- A quick summary and/or background
- Steps to reproduce
  - Be specific!
  - Give sample code if you can.
- What you expected would happen
- What actually happens
- Notes (possibly including why you think this might be happening, or stuff you tried that didn't work)

## Use a Consistent Coding Style
Format your code before pushing any changes

## License
By contributing, you agree that your contributions will be licensed under Apache License 2.0, see [LICENSE](./LICENSE.md).
